<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : Zeit_anzeigen.ips.php
Trigger  : ScriptTimer 1
Interval : 
Author   : HJH
Project  : Bahnhofsuhr
Date     : 11.11.07
*/



// Startzeit fr Laufzeitmessung
$startTime = microtime(true);

// Pfade und Dteien
$project = "Bahnhofsuhr";
$path = IPS_GetKernelDir(). "scripts\\". $project. "\\";
$imgPath = $path. "Images\\";
$clockRawFile = $imgPath. "Uhr.png";
$clockFinalFile = $project. ".png";

// aktuelle Uhrzeit ermitteln
$time = time();
$sekunde = date("s", $time);

if (($sekunde == "0") || GetValueBoolean("Sekunden_Modus") || GetValueBoolean("Sekundenzeiger_anzeigen"))
{
 // Uhr laden
 $img = imagecreatefrompng($clockRawFile);
 imageantialias($img, true);   // Antialiasing aktivieren

 // Zentrum des Bildes ermitteln
 $x = imagesx($img)>>1;        // Division durch 2 durch rechts schieben
 $y = imagesy($img)>>1;        // Division durch 2 durch rechts schieben

 // einige Farben definieren
 $black = 0x000000;            // schwarz
 $grey  = 0x808080;            // grau
 $red   = 0xff0000;            // rot
 $green = 0x00a0a0;            // grn

 // Stundenzeiger
 $stunde = date("g", $time);
 $minute = date("i", $time);
 $color = $black;
 $std = 90.0 - ($stunde*60+$minute)*0.5;         // Winkel berechnen
 Marke($img, $x, $y, $std, 0, 150, 7, $color);   // Zeiger zeichnen

 // Minutenzeiger
 $minute = date("i", $time);
 $color = $black;
 $min = 90.0 - $minute*6.0;                      // Winkel berechnen
 Marke($img, $x, $y, $min, 0, 200, 7, $color);   // Zeiger zeichnen

 // Sekundenzeiger
 if (GetValueBoolean("Sekundenzeiger_anzeigen"))
 {
  $color = $red;
  $sek = 90.0 - $sekunde*6.0;                     // Winkel berechnen
  Marke($img, $x, $y, $sek, 0, 230, 3, $color);   // Zeiger zeichnen
  imagefilledellipse($img, $x, $y, 16, 16, $red); // Achsmittelpunkt zeichnen
  SetValueBoolean("Sekunden_Modus", true);
 }
 else
  SetValueBoolean("Sekunden_Modus", false);

 // Datum als Text einblenden
 $datum = date("d.m.y", $time);
 $textBox = imageftbbox(24.0, 0.0, "arialbd.ttf", $datum);
 $breite = $textBox[2]>>1;
 imagefttext( $img, 24.0, 0.0, $x-$breite, 400, $green, "arialbd.ttf", $datum);

 // fertiges Bild abspeichern
 imagepng($img, $clockFinalFile);

 // den vom Bild bisher belegten Speicher wieder freigegben
 imagedestroy($img);

 // Designer informieren, nderungen anzeigen
 IMGP_SendEvent($project. ".png");
}

// ScriptTimer mit Systemuhr synchronisieren
//if ($sekunde == 15)
//{
// IPS_SetScriptTimer($IPS_SELF, 0);         // Sekundentakt abschalten
// while (time() == $time);                  // auf volle Sekunde warten
// IPS_SetScriptTimer($IPS_SELF, 1);         // Sekundentakt starten
// IPS_RunScript($IPS_SELF);
//}

// Laufzeit in Millisekunden (ms) ermitteln
$runTime = microtime(true) - $startTime;
$runTimeS = sprintf("Laufzeit: %5.2f ms", $runTime*1000);
SetValueString($project. "_Script_Runtime", $runTimeS);



// Funktionen ------------------------------------------------------------------

//******************************************************************************
// Rechteck zeichnen
// =================
//
// Parameter:
// $img        : Bild in das gezeichnet werden soll
// $px, $py    : Koordinaten des Mittelpunkts der schmalen Seite
// $ang        : Winkel, um den das Rechteck gedreht werden soll
// $l          : Abstand des Rechtecks vom Zentrum
// $a, $b      : Lnge und halbe Breite des Rechtecks
// $color      : Farbe des Rechtecks
//
//------------------------------------------------------------------------------
function Marke($img, $x, $y, $ang, $l, $a, $b, $color)
{
 $phi = deg2rad($ang);     // Winkel von Grad nach Radiant umrechnen
 $sin = sin(-$phi);        // Winkel negativ, da Y-Achse nach unten zeigt
 $cos = cos($phi);
 $x0 =  $x + $cos*$l;
 $y0 =  $y + $sin*$l;
 // Koordinaten fr das Polygon-Array berechnen
 $pt[0] = (integer)round($x0 - $sin*$b);
 $pt[1] = (integer)round($y0 + $cos*$b);
 $pt[2] = (integer)round($x0 + $sin*$b);
 $pt[3] = (integer)round($y0 - $cos*$b);
 $pt[4] = (integer)round($x0 + $sin*$b + $cos*$a);
 $pt[5] = (integer)round($y0 - $cos*$b + $sin*$a);
 $pt[6] = (integer)round($x0 - $sin*$b + $cos*$a);
 $pt[7] = (integer)round($y0 + $cos*$b + $sin*$a);
 // ausgeflltes Rechteck zeichnen
 imagefilledpolygon($img, $pt, 4, $color);
 // Randlinie zustzlich zeichnen (wegen Antialiasing)
 imagepolygon($img, $pt, 4, $color);
}
?>
