<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : Zifferblatt.ips.php
Trigger  : 
Interval : 
Author   : HJH
Project  : Bahnhofsuhr
Date     : 15.09.06
*/



//******************************************************************************
//
// Mit diesem Script wird das Zifferblatt einer Uhr erzeugt. Das Bild dient
// dann als Hintergrund fr das Script "Zeit_anzeigen".
//
//******************************************************************************



// Pfade und Dteien
$project = "Bahnhofsuhr";
$path = IPS_GetKernelDir(). "scripts\\". $project. "\\";
$imgPath = $path. "Images\\";
$clockFile = $imgPath. "Uhr.png";
$logoFile = $imgPath. "IPS-Logo 100.png";

// Bild erzeugen 500 x 500 Pixels
$w = 500;                     // Breite
$w2 = $w>>1;                  // Bildmitte horizontal
$h = 500;                     // Hhe
$h2 = $h>>1;                  // Bildmitte vertikal
$img = imagecreatetruecolor($w, $h);
imageantialias($img, true);   // Antialiasing aktivieren

// einige Farben definieren
$white = 0xffffff;            // wei
$clBtnFace = 0xd4d0c8;        // Windows Button-grau
$black = 0x000000;            // schwarz

// leeres Bild grau einfrben
imagefill($img, 0, 0, $clBtnFace);

// Logo einblenden
$logo = imagecreatefrompng($logoFile);
imagecolortransparent($logo, 0x123456);   // transparente Farbe
$w2l = imagesx($logo)>>1;                 // halbe Breite des Logos
imagecopymerge($img, $logo, $w2-$w2l, 100, 0, 0, imagesx($logo), imagesy($logo), 100);
imagedestroy($logo);                      // Bildspeicher des Logos wieder freigeben

// uerer Radius des Ziffernkreises
$r = $w2;

// Minuten-Striche zeichnen
$a = 15;                      // Lnge eines Strichs
$b = 3;                       // halbe Breite eines Strichs
for ($i=0; $i<60; $i++)       // Minuten-Striche zeichnen
 Marke($img, $w2, $h2, $i*6, $r, $a, $b, $black);

// Stunden-Striche zeichnen
$a = 40;                      // Lnge eines Strichs
$b = 7;                       // halbe Breite eines Strichs
for ($i=0; $i<12; $i++)       // Stunden-Striche zeichnen
 Marke($img, $w2, $h2, $i*30, $r, $a, $b, $black);

// Achsen-Mittelpunkt zeichnen
imagefilledellipse($img, $w2, $h2, 30, 30, $black);

// fertiges Zifferblatt abspeichern
imagepng($img, $clockFile);

// den vom Bild bisher belegten Speicher wieder freigegben
imagedestroy($img);



// Funktionen ------------------------------------------------------------------

//******************************************************************************
// Rechteck zeichnen
// =================
//
// Parameter:
// $img        : Bild in das gezeichnet werden soll
// $px, $py    : Koordinaten des Mittelpunkts der schmalen Seite
// $ang        : Winkel, um den das Rechteck gedreht werden soll
// $l          : Abstand des Rechtecks vom Zentrum
// $a, $b      : Lnge und halbe Breite des Rechtecks
// $color      : Farbe des Rechtecks
//
//------------------------------------------------------------------------------
function Marke($img, $x, $y, $ang, $l, $a, $b, $color)
{
 $phi = deg2rad($ang);     // Winkel von Grad nach Radiant umrechnen
 $sin = sin(-$phi);        // Winkel negativ, da Y-Achse nach unten zeigt
 $cos = cos($phi);
 $x0 =  $x + $cos*$l;
 $y0 =  $y + $sin*$l;
 // Koordinaten fr das Polygon-Array berechnen
 $pt[0] = (integer)round($x0 + $sin*$b);
 $pt[1] = (integer)round($y0 - $cos*$b);
 $pt[2] = (integer)round($x0 - $sin*$b);
 $pt[3] = (integer)round($y0 + $cos*$b);
 $pt[4] = (integer)round($x0 - $sin*$b - $cos*$a);
 $pt[5] = (integer)round($y0 + $cos*$b - $sin*$a);
 $pt[6] = (integer)round($x0 + $sin*$b - $cos*$a);
 $pt[7] = (integer)round($y0 - $cos*$b - $sin*$a);
 // ausgeflltes Rechteck zeichnen
 imagefilledpolygon($img, $pt, 4, $color);
 // Randlinie zustzlich zeichnen (wegen Antialiasing)
 imagepolygon($img, $pt, 4, $color);
}
?>
